<?php
/**
 * @package     NextGenEditor
 *
 * @copyright   Copyright (C) Teatis. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      TEATIS - www.nextgeneditor.com
 */

defined('_JEXEC') or die;
defined('JPATH_PLATFORM') or die;
    
    $id = self::getId($name);
    $value = self::getValue($name, 0);    
    $label = self::getLabel($id, $label, $help);  
    $patternLabel = "";
    $patternDescription = "";
    $result = '';
    $canManagePatterns = (!(isset($options['manage']) && ($options['manage'] == false))) && (NGE::features('config.patterns') && JFactory::getUser()->authorise('patterns.manage','com_nge'));
    
    // The active font id field.
    if (0 == (int)$value){
        $value = '';
        $patternLabel = NGE::translate('COM_NGE_FIELD_PATTERN_SELECT_BTN');
	$patternDescription = '';
    }else{
        $value = (int)$value;	
        $defaultPattern = NgePatternDriver::load($value);	
        $patternLabel = isset($defaultPattern->title) ? $defaultPattern->title : '';
	$patternDescription = isset($defaultPattern->description) ? $defaultPattern->description : '';
    }
    $patterns = NgePatternsDriver::loadList($patternType, $patternName, true);

    //If no value : force first available pattern : more user-friendly
    if (($value == '') && count($patterns) > 0)
	$value = $patterns[0]->id;
	
    $result .=       '<div id="'.$id.'" class="ngefield_pattern">';
if (count($patterns) > 20){
    $result .= '<div class="control-group">'
                . '<div class="control-label">&nbsp;</div>'
                . '<div class="controls">';

      $result .= '<div class="input-append">'
                        . '<input class="input-xlarge" type="text" id="'.$id.'_name" value="'.$patternLabel.'" disabled="disabled" size="35" />'
                        . '<div class="btn nge-append-button ngepattern-select-button" type="button"" data-id="' . $id . '" data-name="' . $patternName . '" data-type="' . $patternType . '">'
                            . '<i class="icomoon icomoon-search"></i>&nbsp;'
                        . '</div>'       
                    . '</div>';
      $result .= '<div id="'.$id.'_description">' . $patternDescription . '</div>';
      $result .= '</div></div>';
}
else {
      $result .= '<div id="' . $id . '_ref" data-id="' . $id . '" data-name="' . $patternName . '" data-type="' . $patternType . '" class="row-fluid">';
      
    $description = '';      
      //Left panel
      $result .= '<div class="span3" style="border-right:1px solid #ddd;box-shadow: 0 7px 14px 0 rgba(0,0,0,.3);min-height: 100vh;">';
      $result .= '<div style="position:relative;font-size:24px;font-weigth:bold;color:#fff;background-color:#FF9800;padding:8px;margin-bottom:12px;">' . NGE::translate('COM_NGE_PATTERN_LEGEND_TITLE');
    if ($canManagePatterns)
	    $result .= '<a href="javascript:var value=jQuery(\'#' . $id . '_id\').val();selectPattern(\'' . $id . '\', value, \'' . $patternType . '\', \'' . $patternName . '\');" style="position:absolute;left:140px;top:15px;font-size: 18px;background-color: #F50057;border-radius: 50%;box-shadow: 0 7px 14px 0 rgba(0,0,0,.3);color: #FFFFFF;text-align: center;padding: 10px;margin: 0px 1px;cursor: pointer;">'
                            . '<i class="icomoon icomoon-magic-wand" title="' . NGE::translate('COM_NGE_PATTERNS_MANAGE') . '"></i></a>';      
//      $result .= '<div class="icomoon icomoon-magic-wand" style="position:absolute;font-size: 18px;background-color: #F50057;border-radius: 50%;box-shadow: 1px 1px 1px 0px #ccc;color: #FFFFFF;text-align: center;padding: 10px;margin: 0px 1px;cursor: pointer;"></div>';
      $result .= '</div>';
      $result .= '<div style="text-align:justify;padding:12px">' . NGE::translate('COM_NGE_PATTERN_LEGEND') . '</div>';
/*      if ($canManagePatterns)
	    $result .= '<a href="javascript:var value=jQuery(\'#' . $id . '_id\').val();selectPattern(\'' . $id . '\', value, \'' . $patternType . '\', \'' . $patternName . '\');" style="color: #97ACBF;float:right;">'
                            . '<i class="icomoon icomoon-magic-wand"></i>&nbsp;' . NGE::translate('COM_NGE_PATTERNS_MANAGE') . '</a>';*/
      $result .= '<hr>';
	    //$result .= '<div class="nge-pattern-description">' . $description . '</div>';
      $result .= '<div id="'.$id.'_description" class="ngepatterndescription"></div>';
    
	
    $result .= '</div>';
    
    //Right panel
    $result .= '<div class="span9">';
    
    if(count($patterns) === 0){
	if ($canManagePatterns){ 
		$result .= '<ul class="ngepatterns-list" data-id="' . $id . '" data-name="' . $patternName . '" data-type="' . $patternType . '">';
		$result .= '<li id="ngeinline-pattern-add" class="ngeinline-pattern-add" style="padding-top:20px;line-height: 15px;" data-title="" data-description=""><span style="font-size:48px">+</span><br/>'.NGE::translate('COM_NGE_PATTERN_TITLE_CREATE').'</li>';
		$result .= '</ul>';
	    }
	    else {
		$result .= '<div class="ngePreviewInformation" style="margin-top:50px;">
		<button type="button" class="close" data-dismiss="alert">&times;</button>
		<h4><span class="icomoon icomoon-warning"></span>&nbsp;' . NGE::translate('COM_NGE_PREVIEW_INFO').'</h4>'.
		NGE::translate('COM_NGE_FIELD_NO_PATTERN'). '</div>';
	    }
	
    }else{
	if (NGE::features("nge.dev"))
	$result .= '<ul class="ngepatterns-list" data-id="' . $id . '" data-name="' . $patternName . '" data-type="' . $patternType . '" style="transform: scale(0.5);width:200%;transform-origin: top left;height:100%;margin:20px 0 0 0;">';
	else
	    $result .= '<ul class="ngepatterns-list" data-id="' . $id . '" data-name="' . $patternName . '" data-type="' . $patternType . '" >';
        foreach ($patterns as $pattern){
            $active = $pattern->id == $value ? 'class="active"' : '';	    
            if ($pattern->id == $value)
                $description = $pattern->description;
            //$result .= '<li ' . $active . 'data-id="' . $pattern->id . '" data-description="' . $pattern->description . '">' . $pattern->title . '</li>';
	    if (NGE::features("nge.dev")){
		$result .= '<li ' . $active . 'data-id="' . $pattern->id . '" data-description="' . $pattern->description . '" style="width:400px;overflow:hidden;">';
		$result .= $pattern->thumbnail;
		$result .= '</li>';
	    }
	else 
	    $result .= '<li ' . $active . 'data-id="' . $pattern->id . '" data-description="' . $pattern->description . '">' . $pattern->title . '</li>';
        }
        $result .= '</ul>';
    }
    $result .= '</div>';
    $result .= '</div>';
    
}	
	
        $result .= '<input type="hidden" class="ngepatterns-id" id="' . $id . '_id" name="' . self::inputName($name) . '" value="' . $value . '" />';
	$result .= '</div>';
                /*. '</div>'
            . '</div>';*/		