<?php
/**
 * @package     NextGenEditor
 *
 * @copyright   Copyright (C) Teatis. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      TEATIS - www.nextgeneditor.com
 */
 
// no direct access
defined('_JEXEC') or die;
	
$data = $displayData;

//Width
if ($data->orientation == "horizontal")
switch ($data->width->mode){
	case 'default' : 
		break;
	case 'evenly' : 
		echo $data->selector.'  {
		display: table; 		
		table-layout: fixed; 
		width:100%;
		}';
		echo $data->selector . ' >li {
		display: table-cell;
		float:none;';
		if (isset($data->count) && ($data->count != 0))
			echo 'width:' . str_replace(',', '.', 100/$data->count) . '%;';
		echo '}';
		echo $data->selector . ' >li>a {
		display: block;
		}';
		break;
	case 'available' : 
		echo $data->selector.'  {
		display: table; 
		table-layout: fixed; 
		width: 100%; 
		}';
		echo $data->selector . ' >li {
		display: table-cell;
		float:none;
		width:100%;
		}';
		echo $data->selector . ' >li>a {
		display: block;
		}';
		break;
	
	case 'custom' : 
		echo $data->selector . ' >li {';
		echo 'width:'.$data->width->value.'px;';
		echo '}';	
		break;
}

//Height mode
if ($data->height->mode == 'custom'){
    echo $data->selector . ' >li {	
	padding:0px;
	height: ' . $data->height->value . 'px;';
    echo 'text-align:'.$data->align.';';
    if ($data->valign != 'top')
	echo 'vertical-align:' . $data->valign . ';
	display:table-cell;
	float:none;';
 
    echo '}';
    
}

//Padding
echo $data->selector.' >li> a{';	
	if(isset($data->padding->default) && ($data->padding->default != ""))
	    echo 'padding: '.$data->padding->default . 'px;';
	if(isset($data->padding->left) && ($data->padding->left != ""))
	    echo 	'padding-left: '.$data->padding->left . 'px;';
	if(isset($data->padding->top) && ($data->padding->top != ""))
	    echo 	'padding-top: '.$data->padding->top . 'px;';
	if(isset($data->padding->right) && ($data->padding->right != ""))
	    echo 	'padding-right: '.$data->padding->right . 'px;';
	if(isset($data->padding->bottom) && ($data->padding->bottom != ""))
	    echo 	'padding-bottom: '.$data->padding->bottom . 'px;';			
echo '}';	


//spacing
if ($data->spacing != ''){
	$spacing= is_numeric($data->spacing) ? $data->spacing . 'px' : $data->spacing;
	echo $data->selector.' li:not(:last-child){';
	if ($data->orientation == "horizontal")
		echo 'margin-right:'.$spacing;			
	else		
		echo 'margin-bottom:'.$spacing;
	echo '}';
}
