<?php
/**
 * @package     NextGenEditor
 *
 * @copyright   Copyright (C) Teatis. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      TEATIS - www.nextgeneditor.com
 */
 
// no direct access
defined('_JEXEC') or die;

//Using part class for warning rendering messages
require_once(NGEPATH_LAYOUTS . '/parts/parts/html/part.php');

$data = $displayData;
$data->selector = '#part-'.$data->id;
$html = array();

$part = new LayoutPart($data);

//require_once (NGEPATH_HELPERS . '/data/joomla/menudriver.php');
//$menu = NgeJoomlaMenuDriver::load($data->content->menutype, (int)$data->content->showallchildren);

/***** CONTENT *****/
//$rowsCount = 0;
$items = array();
$contentActive = array();

if ($data->content->source == 'database'){
    if ($data->content->source == 'query' && $data->content->query != ''){
	require_once (NGEPATH_HELPERS . '/data/database/databasedriver.php');
	
	$query = $data->content->query;
	if ($data->content->count != '' && $data->content->count != '0')
		$query .= ' LIMIT 0,'.$data->content->count;
	$contentData = NgeDatabaseDriver::loadAssocList($query);
  //              $rowsCount = count($contentData);
		
                switch ($data->renderer->mode){
                    case 'default' :
			foreach ($contentData as $contentRow) {
			    $htmlRow = '<a href="#">';
			    $firstField = true;
			    foreach ($contentRow as $key=>$value) {
				if ($firstField == true){
				    $htmlRow .= $value ;
				    $firstField = false;
				}
			    }
			    $htmlRow .= '</a>';

			    $items[] = $htmlRow;
			}
                        break;
                    case 'php' :
                        break;
                    case 'template' :
	    require_once (NGEPATH_HELPERS . '/renderer/smarty/smartyrenderer.php');
                        foreach ($contentData as $contentRow) {
	
		if ($data->renderer->template->source == 'html')
			$items[] = SmartyRenderer::renderString($contentRow, $data->renderer->template->html->body);
		else
		if ($data->renderer->template->source == 'file')
			$items[] = SmartyRenderer::render($contentRow, $data->renderer->template->file);		
		}		                        
                        break;                    
                }
    }
}
else
if ($data->content->source == 'menu'){

	require_once (NGEPATH_HELPERS . '/data/joomla/menudriver.php');
		$menu = NgeJoomlaMenuDriver::load($data->content->menu, (int)$data->content_menus_showallchildren[$i]);
		$contentBodys[$i] = '<ul class="dropdown-menu">';
	
	for ($i=0;$i <count($articlesList); $i++){
		$item = new stdClass();
		$item->label = $articlesList[$i]->title;
		$item->link = $articlesList[$i]->link;
		$item->active = $articlesList[$i]->active;
		$items[] = $item;
		//$items[] = '<a href="'.$articlesList[$i]->link.'">'.$articlesList[$i]->title.'</a>';
	}	
}
else //Custom content : input
if ($data->content->source == 'custom') {		
	for ($i=0;$i <count($data->content->items); $i++){
		
		$item = new stdClass();

		//Label
		$glyphleft = ($data->content->items[$i]->glyph->name != '' && $data->dropdown->items->glyph->position == 'left') ? '<span class="icomoon-left icomoon '.$data->content->items[$i]->glyph.'"></span>' : '';
		$glyphright = ($data->content->items[$i]->glyph->name != '' && $data->dropdown->items->glyph->position == 'right') ? '<span class="icomoon-right icomoon '.$data->content->items[$i]->glyph.'"></span>' : '';
		$item->label = $glyphleft.$data->content->items[$i]->label.$glyphright;

		//Link	
		$item->active = false;
		//$contentActive[$i] = '';

		switch ($data->content->items[$i]->link->type){
			case 'url' :
				$item->link = $data->content->items[$i]->link->url;
				break;
			case 'article' :
				// compare current article ID if exist with article in data
				$jinput = JFactory::getApplication()->input;
				$option = $jinput->get('option','');
				$view = $jinput->get('view','');
				$idarticle = $jinput->get('id','');
				if($option=='com_content' && $view=='article') {
					if($data->content->items[$i]->link->article==$idarticle)	
						$item->active = true;
				}
			
				$item->link = NGE::url('root').'index.php?option=com_content&view=article&id='.$data->content->items[$i]->link->article;
				break;
			case 'menu' :
/*				$js = new JSite;
				$menu = $js->getMenu();
				$activemenu = $menu->getActive();
				echo '----------------';
*/								
				require_once (NGEPATH_HELPERS . '/data/joomla/menudriver.php');
				$menu = NgeJoomlaMenuDriver::loadItem($data->content->items[$i]->link->menu);
				
				if (isset($menu)){
				    $link = $menu->route;
				    // active menu?				    
				    if(isset($activemenu) && $activemenu->id==$data->content->items[$i]->link->menu)
					$item->active = true;				    
				    $item->link = NGE::url('root').'index.php/'.$link;        			    
				}
				else{
				    $part->warnings[] = 'COM_NGE_WARNING_MENULINK_MISSING';		    }	
				break;
				
			case 'image' :
				$item->link = NGE::url('root').$data->content->items[$i]->link->image;
				break;
			case 'file' :
				$item->link = NGE::url('root').$data->content->items[$i]->link->file;
				break;
			case 'javascript' :
				$item->link = $data->link_javascripts[$i];
				break;
			case 'submit' :
				$item->link = 'jQuery( "form:first" ).submit();'; //TODO pouvoir indiquer un nom de formulaire
				break;        
			default :
				$item->link = '';
		}
		$items[] = $item;
	}
	/*
	//Only if not in preview mode
	if (isset($data->rendering->mode) && ($data->rendering->mode != 'preview' && $data->rendering->mode != 'edit')){
		$chilId = $i+1;
		$dataButtonJs = new stdClass();
		$dataButtonJs->selector = '#part-'.$data->id.' ul.dropdown-menu li:nth-child('.$chilId.') a';
		$dataButtonJs->url = $data->content->items[$i]->link->url;
		$dataButtonJs->type = $data->content->items[$i]->link->type;
		$dataButtonJs->target = $data->dropdown->link_target;
		$part->script[] = NGE::layout('nge.parts.panels.js.button_js', $dataButtonJs);
	}
	//$items[] = '<a tabindex="-1" style="cursor:pointer;">'.$glyphleft.$data->content->items[$i]->label.$glyphright.'</a>';
*/
	
}
else {
        //Loading plugin contents
    	if ($data->content->source == 'query')
	    $data->content->source = 'database.query';
	if ($data->content->source == 'input')
	    $data->content->source = 'database.input';

    $dataSourceFilename = NGEPATH_CONTENTS . '/source/' . str_replace('.', '/', $data->content->source) . '/content.php';
    if (file_exists($dataSourceFilename)){			
	require_once $dataSourceFilename;
	$className = 'Nge' . implode('', array_map('ucfirst', explode('.', $data->content->source))) . 'Content';
	$source = str_replace('.', '/', $data->content->source);
	//WARNING : $data contains properties from the config screen. 
	//All content properties are not known because they can come from external content plugins
	//So we transmit unchanged all these properties as parameter of the loadList method (params)
	$items = $className::getListData($data);
    }
}

/***** GLOBAL CSS *****/
//Attributes
$class = array();
$class[] = "part";
$class[] = 'btn-group';
$class[] = $data->dropdown->position == 'dropup' ? 	' dropup' : '';

        //Part display options
	$part->style[] = NGE::layout('nge.parts.parts.display_style', $data);
	$class[] = NGE::layout('nge.parts.parts.display_class', $data);
	$part->script[] = NGE::layout('nge.parts.parts.display_script', $data);

$attributes = array();
$attributes[] = ' id="part-'.$data->id.'"';
$attributes[] = ' data-part="'.$data->name.'"';
$attributes[] = ' data-part-label="'.NGE::translate($data->libraryTitle).'"';
$attributes[] = ' class="'.implode(' ', $class).'"';

//Edit mode, xeditable enabled
if ($data->rendering->mode == 'edit'){
	$attributesLabel = 'class="button-label ngeelement ngeinlineeditable ngeinlinetext"  data-nge = \'{"title": "Label", "type": "text", "source":"content:label.html"}\'';
	$attributesSublabel = 'class="button-label ngeelement ngeinlineeditable ngeinlinetext"  data-nge = \'{"title": "Sublabel", "type": "text", "source":"content:sublabel.html"}\'';
}
else {
	$attributesLabel = 'class="button-label"';
	$attributesSublabel = 'class="button-sublabel"';
}	

$class_a = array();
$class_a[] = "btn dropdown-toggle";

// dropdown position
$class_a[] = $data->dropdown->position == 'dropup' ? ' dropup' : '';

$class_button_label = array();
$class_button_label[] = "button_label";
//$class_button_label[] = $data->button->font->style == 'class' ? $data->button->font->class : '';


/**********************************************************************************************
                              BUTTON CSS & JS                                                  
**********************************************************************************************/
//Button CSS
$dataButton = $data->button->padding;
$dataButton->selector = '#part-'.$data->id.' ul.nav li';
$part->style[] = NGE::layout('nge.parts.panels.css.padding_css', $dataButton);

    //*********************** BOOTSTRAP STYLE ***********************************//
    if($data->button->style == 'bootstrap'){
        if(isset($data->button->bootstrap->size) && ($data->button->bootstrap->size != "btn-default")){
            $class_a[] = $data->button->bootstrap->size != '' ? ' '.$data->button->bootstrap->size : '';
        	}
        if($data->button->style == "bootstrap"){
        		$class_a[] = $data->button->bootstrap->theme != '' ? ' btn-'.$data->button->bootstrap->theme : '';
        	}
        
    }
    
    //*********************** CLASS STYLE ***********************************//
    if($data->button->style == 'class'){
        $class_a[] = $data->button->class ;
    }
	//*********************** CUSTOM STYLE ***********************************//

	//$dataHeader = $data->header;
	//$dataHeader->selector = '#part-'.$data->id.' .part_header';
	//$part->style[] = NGE::layout('nge.parts.panels.css.header_css', $dataHeader);

	
	if($data->button->style == 'custom'){

	    	// sublabel hover css if case
		if($data->label->trigger=='hover') {
			$part->style[] = 	'#part-'.$data->id . ' .button-label {visibility : hidden;}';	
			$part->style[] = 	'#part-'.$data->id . ':hover .button-label {visibility : visible;}';	
		}
	    
		$dataButtons = $data->dropdown->items;
		$dataButtons->selector = '#part-'.$data->id . ' ul.nav>li';
		$dataButtons->orientation = $data->dropdown->orientation;
		$dataButtons->count = count($data->content->items);
		$part->style[] = NGE::layout('nge.parts.navigation.css.buttons_css', $dataButtons);
		
		// Font CSS
		if ($data->label->font->style != "default") {	    
		    $dataFont = $data->label->font;
		    $dataFont->selector = '#part-'.$data->id.' > a ';
		    $part->style[] = NGE::layout('nge.parts.text.css.font_css', $dataFont);
	
		    //Button Hover effect css
		    if(isset($data->label->font->color_hover)){
			$part->style[] = "#part-".$data->id." > a:hover {
			    color: ".$data->label->font->color_hover.";
			}";
		    }
		}   
		    
		//Border
		if ($data->button->border->style != "default") {
		    $dataBorder = $data->button->border;
		    $dataBorder->selector = '#part-'.$data->id.' > a';
		    $part->style[] = NGE::layout('nge.parts.panels.css.border_css', $dataBorder);
		}
		
		//Background CSS		
		if ($data->button->background->style != "default") {
		    //Reset current template styles
		    $part->style[] = '#part-'.$data->id.' .btn{background-color: transparent; background-image:none;}';
		    //Apply custom background 
		    if ($data->button->background->style != "default") {
			$dataBackground = $data->button->background;
			$dataBackground->selector = '#part-'.$data->id.' .btn';
			$part->style[] = NGE::layout('nge.parts.panels.css.background_css', $dataBackground);
		    }
		}

		//Button glyph
		if ($data->glyph->name != ""){
		    NgeContenthelper::addStyleSheet(NGEURL_MEDIA . 'icomoon/icomoon-nge.css');
		    $dataGlyph = $data->glyph;
		    $dataGlyph->id = $data->id;
		    $dataGlyph->selector = '#part-'.$data->id.' > a span.icomoon';
		    $part->style[] = NGE::layout('nge.parts.panels.css.icomoon_css', $dataGlyph);
		}	
	
		//Shadow
		if($data->button->shadow->style != 'none'){
		    $dataShadow = $data->button->shadow;
		    $dataShadow->selector = '#part-'.$data->id.' > a';
		    $part->style[] = NGE::layout('nge.parts.panels.css.shadow_css', $dataShadow);
		}
        
	}

        //Button Caret CSS
        $part->style[] = NGE::layout('nge.parts.navigation.css.caret_css', $data);

//Button BoostrapColor JS
if ($data->button->style == 'outline' || $data->button->style == 'transparent'){
	$dataBootstrapColor = $data->button;
	$dataBootstrapColor->selector = '#part-'.$data->id.' > a';
	$dataBootstrapColor->id = $data->id;
	$part->script[] = NGE::layout('nge.parts.navigation.js.getBootstrapColor_js', $dataBootstrapColor);
}




//Button Font CSS
/*if(isset($data->button->font->style) && ($data->button->font->style == 'custom')){
	$dataFont = $data->button->font;
	$dataFont->selector = '#part-'.$data->id.' > a span.button-label';
	$dataFont->color_hover = null; //Because is already define above
	$part->style[] = NGE::layout('nge.parts.text.css.font_css', $dataFont);
}*/

//Button Icomoon CSS
/*$dataButtonIcomoon = $data->button->glyph;
$dataButtonIcomoon->id = $data->id;
$dataButtonIcomoon->selector = '#part-'.$data->id.' > a span.icomoon';
$part->style[] = NGE::layout('nge.parts.panels.css.icomoon_css', $dataButtonIcomoon);*/


/**********************************************************************************************
                                DROPDOWN CSS & JS                                              
**********************************************************************************************/

$dataPadding = $data->dropdown->padding;
$dataPadding->selector = '#part-'.$data->id.' ul.dropdown-menu';
$part->style[] = NGE::layout('nge.parts.panels.css.padding_css', $dataPadding);


//Dropdown panel background
$dataPanelBackground = clone( $data->dropdown->background);
$dataPanelBackground->color_hover = '';
$dataPanelBackground->color_active = '';
$dataPanelBackground->selector = '#part-'.$data->id.' ul.dropdown-menu';
$part->style[] = NGE::layout('nge.parts.panels.css.background_css', $dataPanelBackground);
$part->style[] = "#part-".$data->id." ul.dropdown-menu {overflow: hidden;}";

//Dropdown panel Border
if(isset($data->dropdown->border) && ($data->dropdown->border->style != "default")){
	$dataPanelBorder = $data->dropdown->border;
	$dataPanelBorder->selector = '#part-'.$data->id.' ul.dropdown-menu';
	$part->style[] = NGE::layout('nge.parts.panels.css.border_css', $dataPanelBorder);
}

//Dropdown panel Shadow
if(isset($data->dropdown->shadow) && ($data->dropdown->shadow->style != "default")){
	$dataPanelShadow = $data->dropdown->shadow;
	$dataPanelShadow->selector = '#part-'.$data->id.' ul.dropdown-menu';
	$part->style[] = NGE::layout('nge.parts.panels.css.shadow_css', $dataPanelShadow);
}

/*Dropdown Items**************************/
	    if ($data->dropdown->items->style == "custom") {

		//Items display
		$dataItems = $data->dropdown->items;
		$dataItems->selector = '#part-'.$data->id.' ul';
		$dataItems->orientation = $data->dropdown->orientation; // TOCHECK not used?
		$part->style[] = NGE::layout('nge.parts.panels.css.items_dropdown_css', $dataItems);

		//Dropdown items font CSS
		if(isset($data->dropdown->items->font) && ($data->dropdown->items->font->style == 'custom')){
			$dataPanelFont = $data->dropdown->items->font;
			$dataPanelFont->selector = '#part-'.$data->id.' ul.dropdown-menu li a';
			$part->style[] = NGE::layout('nge.parts.text.css.font_css', $dataPanelFont);
			//adjust dropdown li line height
			$lineheight = round( (int)$data->dropdown->items->font->size*1.2,0);
			$part->style[] = "#part-".$data->id." ul.dropdown-menu li, #part-".$data->id." ul.dropdown-menu li a {
						line-height: ". $lineheight ."px !important;
				}";

			$part->style[] = "#part-".$data->id." ul.dropdown-menu li.active a {
						color: ".$data->dropdown->items->font->color_active.";
				}";
		}

		//Dropdown items Border
		if(isset($data->dropdown->items->border) && ($data->dropdown->items->border != "default")){
			$dataPanelBorder = $data->dropdown->items->border;
			$dataPanelBorder->selector = '#part-'.$data->id.' li';
			$part->style[] = NGE::layout('nge.parts.panels.css.border_css', $dataPanelBorder);
		}

		//Dropdown items background
		//$dataPanelBackground = clone( $data->dropdown->items->background);
		$dataPanelBackground = $data->dropdown->items->background;
		//$dataPanelBackground->color_hover = '';
		//$dataPanelBackground->color_active = '';
		$dataPanelBackground->selector = '#part-'.$data->id.' li a';
		$part->style[] = NGE::layout('nge.parts.panels.css.background_css', $dataPanelBackground);
		//$part->style[] = "#part-".$data->id." ul.dropdown-menu {overflow: hidden;}";

	    }

//Dropdown panel Shadow
if(isset($data->dropdown->items->shadow)){
	$dataPanelShadow = $data->dropdown->items->shadow;
	$dataPanelShadow->selector = '#part-'.$data->id.' ul.dropdown-menu';
	$part->style[] = NGE::layout('nge.parts.panels.css.shadow_css', $dataPanelShadow);
}

// if dropdown rendering mode = scroll, calc dropdown width
if($data->dropdown->rendering->mode == 'scroll' && count($items)>$data->dropdown->rendering->scroll->visibleitems) {
	// add scripts
	$datadropscroll = $data->dropdown;
	$datadropscroll->selector = '#part-'.$data->id.' ul.dropdown-menu';
	$datadropscroll->id = $data->id;
	$part->script[] = NGE::layout('nge.parts.navigation.js.dropdown_scroll_js', $datadropscroll);
}
 
//Button Icomoon CSS
$dataPanelIcomoon = new stdClass();
$dataPanelIcomoon = $data->dropdown->items->glyph;
$dataPanelIcomoon->trigger = '';
$dataPanelIcomoon->id = $data->id.' ul.dropdown-menu li a';
$dataPanelIcomoon->selector = '#part-'.$data->id.' ul.dropdown-menu li a .icomoon';
/*$dataPanelIcomoon->color = $data->dropdown->font->color;
$dataPanelIcomoon->color_hover = $data->dropdown->font->color_hover;
$dataPanelIcomoon->size = $data->dropdown->font->size;
$dataPanelIcomoon->position = "unknown";*/
$part->style[] = NGE::layout('nge.parts.panels.css.icomoon_css', $dataPanelIcomoon);


/***** HTML *****/
$buttonLabel = '<span class="'.implode($class_button_label, ' ').'">'.$data->label->html.'</span>';

//$label = '<span style="display:table-cell">'.$buttonLabel . '</span>';
//$sublabel = ''; //Not implemented

   // $glyphleftButton = '';
    //$glyphrightButton = '';
    /*
    if(isset($data->glyph->name) && $data->glyph->name!='') {        
		$glyphleftButton = (isset($data->glyph->position) && $data->glyph->position == 'left') ? '<span class="icomoon '.$data->glyph->name.'" style="display:table-cell; vertical-align:middle; padding-right:8px"></span>' : '';
		$glyphrightButton = (isset($data->glyph->position) && $data->glyph->position == 'right') ? '<span class="icomoon '.$data->glyph->name.'" style="display:table-cell; vertical-align:middle; padding-left:8px"></span>' : '';
	}
*/
    if(isset($data->glyph->name) && $data->glyph->name!='') {        
	if ($data->button->style == 'custom'){
		switch ($data->glyph->position){
			case 'top':
				$glyphBackgroundSize = $data->glyph->size + 20;
				$label = '<span '.$attributesLabel.'>'.$buttonLabel .'<span class="caret"></span></span>';
				$glyphtop =  '<span class="icomoon '.$data->glyph->name.'"></span>';		
				$content = $glyphtop . '<br/>' . $label;
				break;
			case 'bottom':
				$label = '<span '.$attributesLabel.'>'.$buttonLabel .'<span class="caret"></span></span>';
				$glyphbottom =  '<span class="icomoon '.$data->glyph->name.'"></span><br/>';			
				$content = $label . '<br/>' . $glyphbottom;
				break;
			case 'right':
				$label = '<span style="display:table-cell"><span '.$attributesLabel.'>'.$buttonLabel .'</span><span class="caret"></span></span>';
				$glyphright = '<span class="icomoon '.$data->glyph->name.'" style="display:table-cell; vertical-align:middle; padding-left:8px"></span>';
				$content = $label . $glyphright;
				break;
			default :
				$label = '<span style="display:table-cell"><span '.$attributesLabel.'>'.$buttonLabel .'</span><span class="caret"></span></span>';
				$glyphleft = '<span class="icomoon '.$data->glyph->name.'" style="display:table-cell; vertical-align:middle; padding-right:8px"></span>';			
				$content = $glyphleft . $label;
		}	
	}
	else {
		$label = '<span style="display:table-cell"><span '.$attributesLabel.'>'.$buttonLabel .'</span><span class="caret"></span></span>';
		$glyphleft = '<span class="icomoon '.$data->glyph->name.'" style="display:table-cell; vertical-align:middle; padding-right:8px"></span>';	
		$content = $glyphleft . $label;	
	}
    }
	else
		$content = '<span ' . $attributesLabel . '><span>' . $buttonLabel . '</span></span><span class="caret"></span>';		
	
$html[] = '<div '.implode($attributes).'>';
$html[] = '<a class="'.implode($class_a, ' ').'" data-toggle="dropdown" href="#">';
//$html[] = '<span style="display:inherit">'.$glyphleftButton.$label.$glyphrightButton.'</span>';
$html[] = $content;
$html[] = '</a>';


/******************************************************************
* 
* rendering html dropdown items  
* 
*******************************************************************/
	
    //Dropdown list is editable if custom and edit mode
    $addableAttributes = '';
    $addableClass = '';
    if ($data->rendering->mode == 'edit'){
	//Removable and sortable items
	$class_list = '';
	if (isset($data->content->mode) && (in_array($data->content->mode, array('custom', 'joomla.articles', 'joomla.menu')))){
	    $addableClass .= ' ngeaddableitems ngeitemsremovable';
	    if ($data->content->mode == 'custom' || ($data->content->mode == 'joomla.articles' && $data->content->articles->ordering == 'ordering') || ($data->content->mode == 'joomla.menu'))
		$addableClass .= ' ngeitemssortable';	    
	    $addableAttributes .= 'data-nge=\'{"itemsmode": "link_' . str_replace('.', '_', $data->content->mode) . '", "itemstype": "menu"}\'';
	}	
    }

// normal html rendering for mode default or scroll
//if($data->dropdown->rendering->mode == 'default' || $data->dropdown->rendering->mode == 'scroll') {
	$html[] = '<ul class="dropdown-menu'.$addableClass.'" '.$addableAttributes . '>'; // ul tag start

		// li tag rendering
		for ($i=0;$i <count($items); $i++){
		    $attributesLinkEditable = (isset($data->content->mode) && $data->content->mode == 'custom') && $data->rendering->mode == 'edit' ? ' class="ngecontenteditableinline" data-type="inline" data-property="labels.'.$i.'"' : '';
		//    $html[] = '<li '.$contentActive[$i].'>'.$items[$i].'</li>';
			$active = (isset($items[$i]->active) && ($items[$i]->active ==true)) ? ' class="active"' : '';
			//$html[] = '<li' . $items[$i]->active ? ' class="active"' : ''. '><a href="'.$items[$i]->link.'">' . $items[$i]->label . '</a></li>';
			$html[] = '<li' .  $active . '><a href="'.$items[$i]->link.'" '.$attributesLinkEditable.'>' . $items[$i]->label . '</a></li>';
			
		} //End for
		
	$html[] = '</ul>'; // ul tag end
//}


//IMPORT STYLES CSS &  SCRIPTS JS
$html[] = $part->renderScripts();

$html[] = '</div>';

//PATH LIBRARIES CSS
$libraries_css[] = 'media/com_nge/icomoon/icomoon-nge.css';
	
//IMPORT LIBRARIES CSS & JS
if (count($libraries_css) != 0){
	foreach ($libraries_css as $css) {
		echo '<link rel="stylesheet" href="'.NGE::url('root').$css.'" type="text/css" />';
	}
}

//GENERATE HTML
echo $part->renderMessages();
echo implode($html);
