<?php
/**
 * @package     NextGenEditor
 *
 * @copyright   Copyright (C) Teatis. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      TEATIS - www.nextgeneditor.com
 */
// No direct access
defined('_JEXEC') or die;
 
$data = $displayData;

//Inlineediting
if($data->rendering->mode == 'edit'){    

	//Header label    
	$inlineeditableClass = ' ngeinlineeditable ngeinlinetext';	
	//if (1 == 1) //Langue différente
	  //  $attributes = ' data-text=\'' . $data->header->label . '\' data-nge = \'{"title": "Header", "type": "text", "source":"content:header.label", "text":"' . $data->header->label . '"}\'';
	//else
	    $attributes = ' data-nge = \'{"title": "Header", "type": "text", "source":"content:header.label"}\'';	    

	//Glyph
	$glyphEditableClass = ' ngeelement ngeinlineeditable';
	$glyph_name = (isset($data->header->glyph->name) && $data->header->glyph->name != '') ? $data->header->glyph->name : '';
	$glyphEditableAttributes = ' data-nge = \'{"title": "Glyph", "type": "glyph", "source":"content:header.glyph.name", "value":"'.$glyph_name.'", "name":"'.$glyph_name.'"}\' ';

	//Panel header options
	$headerEditableClass = ' ngeinlineeditable ngeelement';
	$headerEditableAttributes = ' data-nge = \'{"title": "Header", "type": "panel.header", "source":"params:header", "name":"XXXX"}\' ';
	$headerEditableAttributes .= ' data-ngeelement = \'{"title": "Header", "type": "nge.panel.header", "source":"params"}\' ';	
	
}
else {
    $inlineeditableClass = '';
    $attributes = '';
    $xeditable_class = '';
    $glyphEditableClass = '';
    $glyphEditableAttributes = '';
    $headerEditableClass = '';
    $headerEditableAttributes = '';    
}

//glyph
if (isset($data->header->glyph->name) && ($data->header->glyph->name != '')){
    $glyphleft = $data->header->glyph->position == 'left' ? '<span id="part-'.$data->id.'-header-glyph" class="icomoon '.$data->header->glyph->name.' '.$data->header->glyph->color.$glyphEditableClass.'"'.$glyphEditableAttributes.'></span>' : '';
    $glyphright = $data->header->glyph->position == 'right' ? '<span id="part-'.$data->id.'-header-glyph" class="icomoon '.$data->header->glyph->name.' '.$data->header->glyph->color.$glyphEditableClass.'"'.$glyphEditableAttributes.'></span>' : '';
}
else{
    $glyphleft = '';
    $glyphright = '';
}

//Header
$content_header = $data->header->label;

switch ($data->header->font->style) {
	case 'custom':
		$content_header = $glyphleft.'<'.$data->header->tag.' class="header_title '.$inlineeditableClass.'" style="display:inline;" '.$attributes.'>'.$content_header.'</'.$data->header->tag.'>'.$glyphright;
		break;
	case 'class':
		$span_class = ($data->header->font->style == "class") ? 'class="'.$data->header->font->class.'"' : "";
		$content_header = $glyphleft.'<'.$data->header->tag.' '.$span_class.'  style="display:inline;">'.$content_header.'</'.$data->header->tag.'>'.$glyphright;
		break;
	case 'default':
	default :
		$content_header = $glyphleft.'<'.$data->header->tag.' class="'.$inlineeditableClass.'" style="display:inline;" '.$attributes.'>'.$content_header.'</'.$data->header->tag.'>'.$glyphright;
		break;
}
//One extra div overflow hidden for the slide effect onto the header.
//TODO bug when positionning on the sides of the body
//echo '<div style="overflow:hidden"><div id="part-'.$data->id.'-header" class="part_header' . $headerEditableClass . '"' . $headerEditableAttributes . '><div id="part-'.$data->id.'-header-content">'. $content_header .'</div></div></div>';
echo '<div id="part-'.$data->id.'-header" class="part_header' . $headerEditableClass . '"' . $headerEditableAttributes . '><div id="part-'.$data->id.'-header-content">'. $content_header .'</div></div>';
