<?php
/**
 * @package     NextGenEditor
 *
 * @copyright   Copyright (C) Teatis. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      TEATIS - www.nextgeneditor.com
 */
// No direct access
defined('_JEXEC') or die;

 /*
 * JSSOR documentation :
 * http://www.jssor.com/development/reference-options.html
 * http://www.jssor.com/development/reference-ui-definition.html
 * http://www.jssor.com/development/reference-api.html
 * */
$data = $displayData;

	switch ($data->playing->end){
		case 'stop' :
			$loop = '0';
			break;
		case 'rewind' :
			$loop = '2';
			break;
		default : //loop
			$loop = '1';
			break;
	}

	$pauseOnHover = 3;
	switch ($data->playing->pausehover) {
		case 'pause' :
			$pauseOnHover = 3;
			break;
		case 'freeze' :
			$pauseOnHover = 12;
			break;
		default :
			$pauseOnHover = 0;
			break;
	}		
       
	switch ($data->navigator->arrows->display){
		case 'never' :
			$ChanceToShowArrows = '0';
			break;
		case 'always' :
			$ChanceToShowArrows = '2';
			break;
		default :
			$ChanceToShowArrows = '1';
	}
	
	switch ($data->navigator->bullets->display){
		case 'never' :
			$ChanceToShowBullets = '0';
			break;
		case 'always' :
			$ChanceToShowBullets = '2';
			break;
		default :
			$ChanceToShowBullets = '1';
	}

	$bulletOrientation = $data->navigator->bullets->orientation == 'vertical' ? '2' : '1';
	$bulletAutocenter = $data->navigator->bullets->orientation == 'vertical' ? '2' : '1';

	$playOrientation = $data->slider->orientation == "vertical"? '2' : '1';

	if ($data->navigator->arrows->positions->horizontal->position == 'outside'){
		$mainMargin = ($data->navigator->arrows->background->width + $data->navigator->arrows->positions->horizontal->margin )* 2;
	}
	else {
		$mainMargin = '0';
	}	

/*echo '
jQuery(document).ready(function() {	';				
*/

	if($data->playing->auto == "1" && $data->playing->transition->display != '0'){
	echo 'var _SlideshowTransitions'.$data->id.' = [';
				echo $data->playing->transition->value;
	echo '];';
	}
		echo '	
	var options'.$data->id.' = {
		$FillMode: '.$data->slider->fillmode.',
		$Loop: '.$loop.',          
		$HWA: false,';
		switch ($data->playing->start->mode) {
			case 'random' :
				$startIndex = rand(0, $data->count);
					echo '$StartIndex: '. $startIndex.',';
				break;
			case 'custom' :
				if(is_int((int)$data->playing->start->index)){
					$startIndex = (int)$data->playing->start->index - 1;
					
					if ($startIndex > $data->count)
						$startIndex = $data->count;
					
					echo '$StartIndex: '.(int)$startIndex.',';
				}	
				break;
			default : //first
				break;
		}
		
		echo '$PauseOnHover: '.$pauseOnHover.',';
		
		if($data->playing->auto == "1"){
			echo '$AutoPlay: true,
			$AutoPlaySteps: '.$data->playing->steps.',
			$AutoPlayInterval: '.$data->playing->speed.','; 
			
			if($data->playing->transition->display != '0'){
				echo '$SlideshowOptions: {
					$Class: $JssorSlideshowRunner$,
					$Transitions: _SlideshowTransitions'.$data->id.',
					$TransitionsOrder: 1
				},';
			}else{
				echo '$SlideDuration: '.$data->playing->duration.',
					$SlideEasing: $JssorEasing$.$EaseLinear,';
			}
		}
		
		if($data->playing->arrowkeynavigation == "1")
			echo '$ArrowKeyNavigation: true,';
			
		if($data->slider->slidesnumber != '1'){
			echo '$DisplayPieces: '.$data->slider->slidesnumber . ',';  

//			$slideWidth = ((int)$data->slider->width - (int)$data->slider->slidespacing) / (int)$data->slider->slidesnumber;
//			echo '$SlideWidth: '.$slideWidth. ','; 
		}
		//else{
			//$slideWidth = (int)$data->slider->width -100;
			//echo '$SlideWidth: '.$slideWidth . ','; 
		//}	
		
		if($data->slider->slidespacing != '0')
			echo '$SlideSpacing: '.$data->slider->slidespacing . ',';  
		

		echo '$PlayOrientation: '.$playOrientation.',       
		$DragOrientation: '.$playOrientation.',';
		
		
	// ***** Arrows navigation *****************************************	

		
	echo '$ArrowNavigatorOptions: {
        	$Class: $JssorArrowNavigator$,
            $ChanceToShow: '.$ChanceToShowArrows.',
            $AutoCenter: 2,
        	$Steps: '.$data->navigator->arrows->steps.',
        	$Scale: false                
        },';
        	
	// ***** Bullets navigation *****************************************
		
        echo '$BulletNavigatorOptions: {
        	$Class: $JssorBulletNavigator$,
            $ChanceToShow: '.$ChanceToShowBullets.',
        	$AutoCenter: 3,
        	$Steps: '.$data->navigator->bullets->steps.',
        	$Lanes: 1,
        	$SpacingX: '.$data->navigator->bullets->spacing.',
        	$SpacingY: '.$data->navigator->bullets->spacing.',
        	$Scale: false,	
        	$Orientation: '.$bulletOrientation.'
        },';
	
	// ***** Thumbnails navigation *****************************************
        switch ($data->navigator->thumbnails->display){
        	case 'never' :
        		$ChanceToShow = '0';
        		break;
        	case 'always' :
        		$ChanceToShow = '2';
        		break;
        	default :
        		$ChanceToShow = '1';
        }
	        echo '$ThumbnailNavigatorOptions: {
	        	$Class: $JssorThumbnailNavigator$,
	            $ChanceToShow: '.$ChanceToShow.',
	            $ActionMode: 1,                                 
	            $SpacingX: 8,                             
	            $DisplayPieces: 10,                           
	            $ParkingPosition: 360
	        }
	};';		

			
	echo 'var options = {
                $AutoPlay: true,                                    
                $AutoPlayInterval: 1500,                            
                $PauseOnHover: 1,                                

                $DragOrientation: 3,                                
                $ArrowKeyNavigation: true,   			            
                $SlideDuration: 800,                                

                

                $ArrowNavigatorOptions: {                       
                    $Class: $JssorArrowNavigator$,              
                    $ChanceToShow: 1                               
                },

                $ThumbnailNavigatorOptions: {                       
                    $Class: $JssorThumbnailNavigator$,              
                    $ChanceToShow: 2,                               
                    $ActionMode: 1,                                 
                    $SpacingX: 8,                                   
                    $DisplayPieces: 10,                             
                    $ParkingPosition: 360                          
                }
            };';		
			
	echo 'jQuery("#part-'. $data->id.'-container").css("visibility", "visible");
		/*jssor_slider'.$data->id.' = new $JssorSlider$("' . $data->selector . '", options'.$data->id.');*/
			jssor_slider'.$data->id.' = new $JssorSlider$("' . $data->selector . '", options);
				
		/*createSlider'.$data->id.'();*/';
    
	echo '   
	function createSlider'.$data->id.'() {
		console.log("CREATE SLIDER '.$data->id.'");
		var outerWidth = jQuery("#part-' . $data->id . '").width();
		var slideWidth = outerWidth-'.$mainMargin.';';
	if ($data->slider->slidesnumber != 1){
		echo 'slideWidth = slideWidth - '.$data->slider->slidespacing.' *('.$data->slider->slidesnumber.'-1);
			slideWidth = slideWidth / '.$data->slider->slidesnumber.';';
	}
	
	$topMargin = $data->navigator->bullets->position == 'outsidetop' ? '+' . strval($data->navigator->bullets->size + 2 * $data->navigator->bullets->margin) : '';	
	$bottomMargin = $data->navigator->bullets->position == 'outsidebottom' ? '+' . strval($data->navigator->bullets->size + 2 * $data->navigator->bullets->margin) : '';	
	echo 'var marginSlide = '.$mainMargin.'/2;
		var maxslideHeight = 0;
		
		jQuery("#part-'. $data->id.'-container >div").css("width", slideWidth).css("left", marginSlide);
		/* Wait for images sizes */	
		 /*setTimeout(function() {*/
			jQuery("#part-'. $data->id.'-container").find(".thumbnail-container").each(function() {
				console.log(jQuery(this).height());
				maxslideHeight = Math.max(jQuery(this).height(), maxslideHeight);			
			});	
			console.log("create '.$data->id.'");';
			if ($topMargin != '')	
				echo 'jQuery("#part-'. $data->id.'-container").css("width", outerWidth).height(maxslideHeight'.$bottomMargin.').css("top", '.$topMargin.');';
			else		
			if ($bottomMargin != ''){	
				echo 'jQuery("#part-'. $data->id.'").css("width", outerWidth).height(maxslideHeight'.$bottomMargin.');';
				echo 'jQuery("#part-'. $data->id.'-container").css("width", outerWidth).height(maxslideHeight'.$bottomMargin.');';
			}
			else
				echo 'jQuery("#part-'. $data->id.'-container").css("width", outerWidth).height(maxslideHeight);';
			
			echo 'jQuery("#part-'. $data->id.' .nge-slider-slide").css("width", outerWidth).height(maxslideHeight);
				
			jQuery("#part-'. $data->id.'-container >div").height(maxslideHeight);';
			
			
			//Images fit
			if ($data->content->mode = 'images'){
				switch ($data->slides->images->fit){
					case 'width':
						echo 'jQuery("#part-'. $data->id.' .thumbnail-body img").width("100%");';
						break;
					case 'height':
						echo 'jQuery("#part-'. $data->id.' .thumbnail-body img").height(maxslideHeight);';
						break;
					case 'initial':
						break;
					case 'stretch':
						echo 'jQuery("#part-'. $data->id.' .thumbnail-body img").width("100%");';
						echo 'jQuery("#part-'. $data->id.' .thumbnail-body img").height(maxslideHeight);';
						break;
					case 'fill':
						break;
				}
			}


			echo 'options'.$data->id.'.$SlideWidth = slideWidth;

			jssor_slider'.$data->id.' = new $JssorSlider$("' . $data->selector . '", options'.$data->id.');
			
		/*}, 100);*/
	}';
	
	echo ' 
	function updateSlider'.$data->id.'() {
		console.log("UPDATE SLIDER '.$data->id.'");
		jQuery("#part-' . $data->id . ' .nge-slider-slide").eq(1).find(">div").eq(0).remove();			
		jQuery("#part-' . $data->id . ' .nge-slider-slide").eq(0).remove();			
		jQuery("#part-' . $data->id . '-container >span").eq(0).before(jQuery("#part-' . $data->id . '-container >div >div >div"));						
		createSlider'.$data->id.'();			
	
		';
	
	
	switch($data->navigator->arrows->positions->vertical->position){
		case ('top') :
			echo 'jQuery(".jssora01l, .jssora01r").css("top", "'.$data->navigator->arrows->positions->vertical->margin.'px");';
			break;
		case ('bottom') :
			echo 'jQuery(".jssora01l, .jssora01r").css("top", "auto");';
			echo 'jQuery(".jssora01l, .jssora01r").css("bottom", "'.$data->navigator->arrows->positions->vertical->margin.'px");';
			break;
	}
	//bullets
	switch($data->navigator->bullets->position){
		case 'top' :
		case 'outsidetop' :
			echo 'jQuery("#part-'. $data->id.'").find(".jssorb01").css("top", "'.$data->navigator->bullets->margin.'px");';
			break;
		case 'bottom' :
			echo 'jQuery("#part-'. $data->id.'").find(".jssorb01").css("top", "auto");';
			break;
		case 'outsidebottom' :
			echo 'jQuery("#part-'. $data->id.'").find(".jssorb01").css({"bottom": "'.$data->navigator->bullets->margin.'", "top": "auto"});';
			break;
		case 'left' :
			echo 'jQuery("#part-'. $data->id.'").find(".jssorb01").css("left", "20px");';
			break;
		case 'right' :
			echo 'jQuery("#part-'. $data->id.'").find(".jssorb01").css({"left": "auto", "right": "20px"});';
			break;
	}
	switch($data->navigator->bullets->align){
		case 'left' :
			echo 'jQuery("#part-'. $data->id.'").find(".jssorb01").css("left", "20px");';
			break;
		case 'right' :
			echo 'jQuery("#part-'. $data->id.'").find(".jssorb01").css({"left": "auto", "right": "20px"});';
			break;
		case 'top' :
			echo 'jQuery("#part-'. $data->id.'").find(".jssorb01").css("top", "20px");';
			break;
		case 'bottom' :
			echo 'jQuery("#part-'. $data->id.'").find(".jssorb01").css("top", "auto");';
			break;
	}

	echo '}';

	//Scale while resizing. If parent size have changed, rebuild
    echo '
	var resizeTimer;
	function onResizeSlider'.$data->id.'(){
		var jssorElement = jQuery("#' . $data->selector . '");
		if (jQuery(jssorElement).parent().width() != jQuery(jssorElement).width()){
			clearTimeout(resizeTimer);
			resizeTimer = setTimeout(scaleSlider'.$data->id.', 1000);
		}
	}
	
	function scaleSlider'.$data->id.'() {
		jQuery("#part-'. $data->id.'-container").find(".thumbnail-container").each(function() {
			console.log("scale");
			console.log(jQuery(this).height());
			
		});	
			
		updateSlider'.$data->id.'();			


/*
		var parentWidth = jQuery("#' . $data->selector . '").parent().width();
			console.log("scaleSlider");
			console.log(jssor_slider'.$data->id.'.$OriginalWidth());
			console.log(parentWidth);
			jssor_slider'.$data->id.'.$ScaleWidth(parentWidth);
				*/
				/*
	    if (parentWidth) {
	  	  jssor_slider'.$data->id.'.$ScaleWidth(parentWidth);
	    }else{
	    	window.setTimeout(ScaleSlider'.$data->id.', 30);
	  	}*/
		
	}	';

	
		echo ' 
	  	  		
   	/*Scale slider after document ready*/
	window.setTimeout(scaleSlider'.$data->id.', 30);

	/*Scale slider while part marge resizing*/
	jQuery("#' . $data->selector . '").closest(".part").bind("drag", scaleSlider'.$data->id.');
			
	jQuery("#' . $data->selector . '").parent().bind("resize", scaleSlider'.$data->id.');

    /*Scale slider while window load/resize/orientationchange.*/
    /*jQuery(window).bind("load", onResizeSlider'.$data->id.');*/
    jQuery(window).bind("resize", onResizeSlider'.$data->id.');
    jQuery(window).bind("orientationchange", onResizeSlider'.$data->id.');';
	
//echo '});';
