<?php
/**
 * @package     NextGenEditor
 *
 * @copyright   Copyright (C) Teatis. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      TEATIS - www.nextgeneditor.com
 * 
 * Full form for editing part
 * Saving all properties as new ones (replace)
 */
// no direct access
defined('_JEXEC') or die;
?>
<form id="internalform" class="ngeinternalform">
            <div id="nge-config-token"><?php echo JHtml::_('form.token'); ?></div>
</form>
<script>
    var previewIsLoading = false; // Preview is being loaded in ajax, but has not responded yet
    
    jQuery(document).on( "ngeConfigChange", function() {
	    previewPart();
    });
        /*
    function submit() {
	savePart();
    }
    function cancel(){
    };
*/

    function previewPart(){
	if (!previewIsLoading) { //an ajax loading is already in course
	    previewIsLoading = true;
	    /*Get all form data*/
	    //Warning, must specify forms id. selector('form') can take unwanted popup inline forms
	    //All forms to be included in preview or saving must have one of these classes 

	    var $frm = jQuery('form.ngecontentform, form.ngeoptionsform, form.ngedisplayform, form.ngeinternalform');
	    var dataAjax = JSON.stringify($frm.serialize());
	    dataAjax = dataAjax.replace(/\"/g, "");
	    dataAjax += '&<?php echo NGE::token(); ?>=1';
	    jQuery.ajax({
		url: "<?= NGEURL_ROOT; ?>index.php?option=com_nge&task=part.preview&pk=<?= $this->pk; ?>",
		data: dataAjax,
		type: 'POST',
		success: function (html) {
		    previewIsLoading = false;
		    _params.refresh(html);
		}
	    });
	}
    };
    
    function savePart() {	
	
	/*Updating tinymce editor instances*/
	try {
	    if (!(typeof tinymce === "undefined") && !(tinymce == null)) {
		for (var i = 0; i < tinymce.editors.length; i++) {
		    tinymce.editors[i].save();
		}
	    }
	}catch (e) {
	    console.error('error while saving tinyMCE editor : ' + e.message)
	}

	/* update ckeditor instances */
	try {
	    if (typeof CKEDITOR !== 'undefined') {
		CKEDITOR = window.CKEDITOR;
		for (var id in CKEDITOR.instances) {
		    CKEDITOR.instances[id].updateElement();
		}
	    }
	}catch (e) {
	    console.error('error while saving CkEditor editor : ' + e.message)
	}
	
	// separate content and params
	//Content will be saved in the content field, and params in the params field         
	//var obj_data_content = jQuery('#contentform');
	var obj_data_content = jQuery('.ngecontentform');
	var obj_data_params = jQuery('.ngeoptionsform');
	var obj_data_display = jQuery('.ngedisplayform');
	var obj_data_access = jQuery('#accessform');	
	var obj_data_internal = jQuery('.ngeinternalform');

	var str_data_content = JSON.stringify(obj_data_content.serialize());
	var str_data_params = JSON.stringify(obj_data_params.serialize());
	var str_data_display = JSON.stringify(obj_data_display.serialize());
	var str_data_internal = JSON.stringify(obj_data_internal.serialize());
	var str_data_access = JSON.stringify(obj_data_access.serialize());

	str_data_content = str_data_content.replace(/\"/g, "");
	str_data_params = str_data_params.replace(/\"/g, "");
	str_data_display = str_data_display.replace(/\"/g, "");
	str_data_internal = str_data_internal.replace(/\"/g, "");
	str_data_access = str_data_access.replace(/\"/g, "");
	
	var data = {'ngecontent': str_data_content, 'ngeparams': str_data_params, 'ngedisplay': str_data_display, 'ngeinternal': str_data_internal, 'ngeaccess': str_data_access};
	data['<?php echo NGE::token(); ?>'] = 1;
	
        jQuery.ajax({
            url: "index.php?option=com_nge&task=part.save&caller=front&pk=<?= $this->pk; ?>",
            data: data,
            type: 'POST',
            async: false,
            success: function (result) {
                resultobj = JSON.parse(result);
                if (resultobj.result == 0){
                    console.error("Error : unable to save the form");  
                }else {
                    jQuery("#ngeinlinebody").hide();
                    parent.jQuery('#inlineConfigForm').modal("hide");
                    isStored = resultobj.result;
                    _params.submit(resultobj);
                }
            }
        });
    }
</script>
<?php
require NGEPATH_HELPERS .'/forms/fields/ngefields_html.php';