<?php

/**
 * @package     NextGenEditor
 *
 * @copyright   Copyright (C) Teatis. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      TEATIS - www.nextgeneditor.com
 */

defined('_JEXEC') or die;

/***** JOOMLA CORE *****/
/*JHtml::_('behavior.framework');
JHtml::_('behavior.framework','more');
JHtml::_('bootstrap.framework');*/
//JHtml::_('bootstrap.modal');

$user  = JFactory::getUser();
$input = JFactory::getApplication()->input;
//$jform = JForm::getInstance('partsgallery', 'partsgallery', array());
$document = JFactory::getDocument();

//To flush browser cache when NGE version changes
$ngeVersion = '?'. NGE::version();

ob_start();

echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr-fr" lang="fr-fr" dir="ltr">
<head>';
echo '<link rel="stylesheet" href="' . NGEURL_MEDIA . 'bootstrap/bootstrap-2/css/bootstrap.min.css" />
	<link rel="stylesheet" href="' . NGEURL_MEDIA . 'icomoon/icomoon-nge.css' . $ngeVersion . '" />
	<link rel="stylesheet" href="' . NGEURL_MEDIA . 'material/icons/material-icons.css' . $ngeVersion . '" />	    
	<script src="' . NGEURL_ROOT . 'media/system/js/core.js' . $ngeVersion . '"></script>
	<script src="' . NGEURL_MEDIA . 'jquery/jquery.min.js"></script>
	<script src="' . NGEURL_MEDIA . 'bootstrap/bootstrap-2/js/bootstrap.min.js"></script>';

echo '</head><body>';

include('components/com_nge/views/librarygallery/tmpl/default_css.php');
include('components/com_nge/views/librarygallery/tmpl/default_js.php');

?>
<div id="containergallery">
	<div id="headergallery" style="padding:5px;">
		<img src="<?php echo JUri::root(); ?>components/com_nge/assets/images/Logo-NGE-C-4.png" alt="Logo nextgeneditor" style="height: 33px;"/>
		<div class="ngeformbuttons">
		    <i id="ngeconfig_button_cancel" class="material-icons md-24 ngeformbutton">close</i></div>
		</div>
	</div>
<?php
	
	$currentCategory = 0;
	$currentPlugin = '';
	$tabs = array();
	$body = array();
	foreach($this->parts as $part){
		//Packs
		if ($part->category_plugin != $currentPlugin){
			$activeLi = $currentPlugin == '' ? ' active' : '';
			$active = $currentPlugin == '' ? ' active' : '';
			$title = $part->plugin_title != '' ? JText::_($part->plugin_title) : JText::_($part->category_title);
			$tabs[] = '<li id="ngecategory-'.$part->category_plugin.'" class="'.$activeLi . '"><a href="#'.$part->category_plugin.'" data-toggle="tab">'.$title.'</a></li>';
			$body[] = $currentPlugin != '' ? '</ul></td></tr></table></div>' : '';
			$body[] = '<div class="tab-pane ngecategorybody-'.$part->category_plugin . $active.'" id="'.$part->category_plugin.'">';
			$currentPlugin = $part->category_plugin;
		}
		//Categories
		if ($part->category_id != $currentCategory){
			$body[] = $currentCategory != 0 ? '</ul></td></tr></table>' : '';
			$body[] = '<table><tr>';
			$body[] = '<td class="category_back ngecategory-'.$part->category_plugin.'"><div class="category-title">'.JText::_( $part->category_title).'</div></td>';
			$body[] = '<td><ul class="manager thumbs">';
			//$body[] = '<li class="category-title">'.JText::_( $part->category_title).'</li>';
			$currentCategory = $part->category_id;
		}
		//Parts
		$body[] =  '<li id="thumbs_'.$part->name.'" data-part="'.$part->name.'" class="thumbs_hover imgOutline thumb" data-title="'.JText::_($part->title).'" data-description="'.JText::_($part->description).'">';
		$body[] =  '	<div class="height-80">';
		$body[] =  JHtml::_('image', JUri::root().'components/com_nge/parts/'.str_replace('.', '/', $part->name).'/thumb.png', $part->name, null, false, true) ? JHtml::_('image', JUri::root().'components/com_nge/parts/'.str_replace('.', '/', $part->name).'/thumb.png', $part->name) : '<img src="'.JUri::root().'components/com_nge/assets/images/default_thumb.png" />';
		$body[] =  '	</div>';
		$body[] =  '	<div class="legend small" title="'.JText::_( $part->title ).'">';
		$body[] =  JText::_( $part->title );
		$body[] =  '	</div>';
  		$body[] =  '</li>';
		
	}
	$body[] =  '</ul></td></tr></table></div>';
	?>
	
<div class="tabbable">
  <ul class="nav nav-tabs" style="background-color:#646D9C">
	  <?php  echo implode($tabs);  ?>
  </ul>
    <div class="row-fluid" style="display:flex;height:100%;">
	<div class="tab-content span9" style="display: flex;align-items: stretch;">
	  <?php  echo implode($body);  ?>
	</div>
	<div id="containerhelp" class="span3" style="align-items: stretch;flex-wrap: wrap;"><h3 id="parttitle"><?= NGE::translate('NGE_LIBRARY_HELP_TITLE'); ?></h3>
		<div style="position:relative; overflow:hidden;">
		    <div id="partthumb"><div style="width:100%;text-align:center;"><img src="<?php echo NGEURL_ROOT?>/components/com_nge/assets/images/widget_add.png"/></div>
			</div>
			<div id="partdescription"><?= NGE::translate('NGE_LIBRARY_HELP_ADD'); ?>
			    <br/><br/>
			    <?php /*<a>More widgets</a>*/ ?>
			</div>
		</div> 
	</div>
    </div>  
</div>
</div>
</body>

<!--<script src="<?php echo NGEURL_MEDIA ?>tabdrop/js/bootstrap-tabdrop.js"></script>
<link rel="stylesheet" href="<?php echo NGEURL_MEDIA ?>tabdrop/css/tabdrop.css" />-->
</html>
<?php

$content = ob_get_contents();
ob_clean();
//Storing cache
//$user = JFactory::getUser();
//NGE::storeCache($content, 'ngeLibrarygalleryDefault-'.$user, true);
echo $content;