<?php
/**
 * @package     NextGenEditor
 *
 * @copyright   Copyright (C) Teatis. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      TEATIS - www.nextgeneditor.com
 * 
 * WIDGET EDITING GENERAL
 */
// No direct access
defined('_JEXEC') or die;

ob_start();
    echo '<style>';
    //Inline editing
    require NGEPATH_HELPERS . '/editor/inline/editor.inline.css';
    require NGEPATH_HELPERS . '/editor/inline/config/editor.inline.config.css';
    require NGEPATH_HELPERS . '/editor/toolbars/editor.toolbars.css';
    
    //elements Toolbar
    require NGEPATH_HELPERS . '/editor/elements/editor.element.css';
    
    echo '</style>';

    /* Get nge init scripts */
    echo '<script>';
    require NGEPATH_HELPERS . '/editor/editor.nge_js.php';
    require NGEPATH_HELPERS . '/editor/editor.nge.js';
    
    //Toolbars management
    require NGEPATH_HELPERS . '/editor/toolbars/editor.toolbars.js';
    
    //Content inline editing	
    require NGEPATH_HELPERS . '/editor/inline/editor.inline.js';
    require NGEPATH_HELPERS . '/editor/inline/config/editor.inline.config.js';
    require NGEPATH_HELPERS . '/editor/inline/editor.inline_toolbar.js';		
    require NGEPATH_HELPERS . '/forms/elements/toolbar_content_js.php';	
    require NGEPATH_HELPERS . '/forms/elements/toolbar_params_js.php';					 

    //Figaro Highcharts editing
    require NGEPATH_PARTS . '/figaro/helpers/inline/charts/charts_editable.js';
    
    echo '</script>';
    $ngeInitScripts = ob_get_contents();
ob_clean();
?>
<!DOCTYPE html>
<html prefix="og: http://ogp.me/ns#" xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr-fr" lang="fr-fr" dir="ltr">
<head>
	<meta name="viewport" content="width=device-width, initial-scale=1.0" />
	<meta http-equiv="content-type" content="text/html; charset=utf-8" />
        
	<link href="<?= NGEURL_ROOT ?>components/com_nge/assets/css/all.css" rel="stylesheet" type="all" />
	<link href="<?= NGEURL_ROOT ?>components/com_nge/assets/css/screen.css" rel="stylesheet" type="screen" />
	<link href="<?= NGEURL_MEDIA ?>icomoon/icomoon-nge.css" rel="stylesheet"/>
	<link href="<?= NGEURL_MEDIA ?>jquery-ui/jquery-ui.min.css" rel="stylesheet"/>
	<link href="<?= NGEURL_ROOT ?>components/com_nge/assets/css/ngedefault.min.css" rel="stylesheet"/>
	<script src="<?= NGEURL_ROOT ?>media/jui/js/jquery.min.js" type="text/javascript"></script>
	<script src="<?= NGEURL_MEDIA ?>jquery-ui/jquery-ui.min.js" type="text/javascript"></script>
	<script src="<?= NGEURL_ROOT ?>media/jui/js/jquery-noconflict.js" type="text/javascript"></script>
	<script src="<?= NGEURL_ROOT ?>media/jui/js/bootstrap.min.js" type="text/javascript"></script>	
	<script src="<?= NGEURL_MEDIA ?>bootbox/bootbox.min.js" type="text/javascript"></script>
	<script src="<?= NGEURL_MEDIA ?>jquery-ui/jquery.ui.touch-punch.min.js" type="text/javascript"></script>
	<script src="<?= NGEURL_MEDIA ?>ckeditor/ckeditor.js" type="text/javascript"></script>	
	<script src="<?= NGEURL_MEDIA ?>nge/ngetools.js" type="text/javascript"></script>	        
        <style>
            #nge-message-box{
                position: fixed;
                left: 0;
                top: 0;
                z-index: 15001;
            }

            #nge-message-box .nge-message-box-first{
                display:none;
            }

            #nge-message-box .nge-message-box-clone{
                position:relative;
                padding:10px;
                color:#ffffff;
                margin-bottom:2px;
            }

            #nge-message-box .nge-message-box-success{background:#81CE66;}
            #nge-message-box .nge-message-box-warning{background:#F09721;}
            #nge-message-box .nge-message-box-error{background:#E43D26;}
            
            .ngesvghidden{visibility:hidden};
        </style>
</head>
    <body>
        <style>
            .nge-edit-refresh{    
                cursor: pointer;
                font-size: 18px;
                padding: 5px;
                color: #FFFFFF;
                background: #3D7ACC;
                display: inline-block;
                position: absolute;
                left: 50%;
                transform: translate(-50%, 0);
                z-index:1;
            };
        </style>
        <div class="nge-workshop-edit" style="padding:20px;">
            <?php echo $this->partContent; ?>
        </div>
        <div id="nge-message-box">
            <div class="nge-message-box-first nge-message-box-clone">
                <span class="icomoon"></span>
                <span class="nge-message">Test</span>
            </div>
        </div>
        <?php echo $ngeInitScripts; ?>
        <script>
            updateWidgetHtml = function(widgetId, widgetHtml){
                jQuery("#part-"+widgetId).replaceWith(widgetHtml).promise().done(function() {
                    var $widget = jQuery("#part-"+widgetId);
                    var pk = $widget.attr("id").split("-");
                    $widget.addClass('ngeeditablestructure ngeeditablestructurepart').data("nge", {type: "part", id: pk[1]});	
                    /* Enable Inline editing */
                    if(typeof NgeInline !== "undefined"){
                        var $body = jQuery("body");
                        var ngeInline = new NgeInline($body);
                        ngeInline._editing.texts.enable();
                        ngeInline._editing.svg.enable();
                        enableNgeEditingElements($body);
                    }else{
                        console.error("NGE inline librairies are not loaded.");
                    }
                });    
            };
            jQuery( document ).ready(function() {
                jQuery(".part").each(function () {
                    var pk = jQuery(this).attr("id").split("-");
                    var partId = libraryTitle = jQuery(this).data("part-label");
                    jQuery(this).addClass('ngeeditablestructure ngeeditablestructurepart').data("nge", {type: "part", id: pk[1]});	
                });
                /* Enable Inline editing */
                if(typeof NgeInline !== "undefined"){
                    var ngeInline = new NgeInline(jQuery("body"));
                    ngeInline._editing.texts.enable();
                    ngeInline._editing.svg.enable();
                }else{
                    console.error("NGE inline librairies are not loaded.");
                }
	
	<?php
	/* Enable elementToolbar */
	    require NGEPATH_HELPERS . '/editor/elements/editor.element.js';

	    //Include all available plugins
	    $rii = new RecursiveIteratorIterator(new RecursiveDirectoryIterator(NGEPATH_HELPERS . '/editor/elements/plugins'));
	    $files = array(); 
	    foreach ($rii as $file) {
		if ((!$file->isDir()) && ($file->getExtension() == 'js')) {
		    include $file->getPathname();
		}
	    }
	?>
		//Adding editing tags
	

	/* Enabling all other editing capabilities*/
	//jQuery(document).trigger("ngeStartEdition");
	//Lancement manuel des scripts d'édition. TODO A remplacer par l'évnement ngeStartEdition
	
	/************************************************************************************/
	
	//enableNgeChartsEditable();
//	 inlineToolbar = new NgeToolbar("inline");
//	enableNgeInlineToolbar();
	
	//jqueryui in the main document also
	//We can call the draggable function
	 var $currentInlineModal = jQuery("#inlineConfigForm");
	var $currentInlineModalIframe = $currentInlineModal.find(".inlineconfig_iframe");

	$currentInlineModal.draggable({
	    handle: ".modal-header",
	    scroll: false,
	    drag : function(e,ui){            
		//Do not permit to go outside the window      
		if(ui.position.top < 0){   
		    ui.position.top = 0;
		}
		if(ui.position.left > jQuery(window).width() - jQuery(this).width()){   
		    ui.position.left = jQuery(window).width() - jQuery(this).width();
		}
		if(ui.position.left < 0){   
		    ui.position.left = 0;
		}
		if(ui.position.top >(jQuery(window).height() - jQuery(this).height())){   
		    ui.position.top = jQuery(window).height() - jQuery(this).height();
		}
	    }
	});
    
	
	enableNgeInlineConfig();
	enableNgetoolbars();
	enableNgeEditingElements();
//	enableNgeInlineEditingElements();
	/************************************************************************************/
	
	
	
	
	
            });
        </script>
	<?php
	    //Inline Config form
	    require NGEPATH_HELPERS . '/editor/inline/config/modal.inlineconfig.php';

	//elements Toolbar
	    require NGEPATH_HELPERS . '/editor/elements/editor.element_toolbar.php';
            require NGEPATH_HELPERS .'/forms/fields/ngefields_html.php';
	?>
    </body>
</html>